commit 9fa962a5db797665972aaa65426b881754782cfb
Author: Nathaniel Shead <nathanieloshead@gmail.com>
Date:   Wed Feb 12 23:07:43 2025 +1100

    c++: Constrain visibility for CNTTPs with internal types [PR118849]
    
    While looking into PR118846 I noticed that we don't currently constrain
    the linkage of functions involving CNTTPs of internal-linkage types.  It
    seems to me that this would be sensible to do.
    
            PR c++/118849
    
    gcc/cp/ChangeLog:
    
            * decl2.cc (min_vis_expr_r): Constrain visibility according to
            the type of decl_constant_var_p decls.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/template/linkage6.C: New test.
    
    Signed-off-by: Nathaniel Shead <nathanieloshead@gmail.com>

diff --git a/gcc/cp/decl2.cc b/gcc/cp/decl2.cc
index 5cbe4c0ceda..bf8f566b8e3 100644
--- a/gcc/cp/decl2.cc
+++ b/gcc/cp/decl2.cc
@@ -2724,7 +2724,9 @@ min_vis_expr_r (tree *tp, int */*walk_subtrees*/, void *data)
 	/* The ODR allows definitions in different TUs to refer to distinct
 	   constant variables with internal or no linkage, so such a reference
 	   shouldn't affect visibility (PR110323).  FIXME but only if the
-	   lvalue-rvalue conversion is applied.  */;
+	   lvalue-rvalue conversion is applied.  We still want to restrict
+	   visibility according to the type of the declaration however.  */
+	tpvis = type_visibility (TREE_TYPE (t));
       else if (! TREE_PUBLIC (t))
 	tpvis = VISIBILITY_ANON;
       else
